// DIALOG.c
BOOL
CALLBACK
CustomDlgProc( HWND hDlg,
							 UINT uMsg,
							 WPARAM wParam,
							 LPARAM lParam )
{
	BOOL IsRet;
	static BOARD *p_board;

	switch( uMsg ) {
		case WM_INITDIALOG:
			p_board = (BOARD*) lParam;
			SetDlgItemInt( hDlg, IDC_EDITROWS,  p_board->rows,  FALSE );
			SetDlgItemInt( hDlg, IDC_EDITCOLS,  p_board->cols,  FALSE );
			SetDlgItemInt( hDlg, IDC_EDITMINES, p_board->mines, FALSE );
			return TRUE;

		case WM_COMMAND:
			switch( LOWORD( wParam ) ) {
				case IDOK:
					p_board->rows = GetDlgItemInt( hDlg, IDC_EDITROWS, &IsRet, FALSE );
					p_board->cols = GetDlgItemInt( hDlg, IDC_EDITCOLS, &IsRet, FALSE );
					p_board->mines = GetDlgItemInt( hDlg, IDC_EDITMINES, &IsRet, FALSE );
					CheckLevel( p_board );
					EndDialog( hDlg, 1 );
					return TRUE;

				case IDCANCEL:
					EndDialog( hDlg, 1 );
					return TRUE;
			}
			break;
	}

	return FALSE;
}

BOOL
CALLBACK
CongratsDlgProc( HWND hDlg,
								 UINT uMsg,
								 WPARAM wParam,
								 LPARAM lParam )
{
	static BOARD *p_board;

	switch( uMsg ) {
		case WM_INITDIALOG:
			//if (p_board->difficulty != CUSTOM) { // Make sure custom cant get highscore
				PlayWaveFile(1); // Victory Sound
				p_board = (BOARD*) lParam;
				SetDlgItemText( hDlg, IDC_EDITNAME,
				p_board->best_name[p_board->difficulty] );
				return TRUE;
			//} else {
			//	EndDialog( hDlg, 1 ); // Close the cheater. :-)
			//}

		case WM_COMMAND:
			switch( LOWORD( wParam ) ) {
				case IDOK:
					GetDlgItemText( hDlg,
												  IDC_EDITNAME,
												  p_board->best_name[p_board->difficulty],
												  sizeof( p_board->best_name[p_board->difficulty] ) );
					EndDialog( hDlg, 0 );
					return TRUE;

				case IDCANCEL:
					EndDialog( hDlg, 1 );
					return TRUE;
			}
			break;
	}

	return FALSE;
}

BOOL
CALLBACK
TimesDlgProc( HWND hDlg,
						  UINT uMsg,
						  WPARAM wParam,
						  LPARAM lParam )
{
	static BOARD *p_board;
	unsigned i;

	switch( uMsg ) {
		case WM_INITDIALOG:
			p_board = (BOARD*) lParam;

			for( i = 0; i < 3; i++ ) // Set best names.
				SetDlgItemText( hDlg,
											  (IDC_NAME1) + i,
											  p_board->best_name[i] );

			for( i = 0; i < 3; i++ ) // Set best times.
				SetDlgItemInt( hDlg,
											 (IDC_TIME1) + i,
											 p_board->best_time[i],
											 FALSE );
				return TRUE;

		case WM_COMMAND:
			switch( LOWORD( wParam ) ) {
				case IDOK:
				case IDCANCEL:
					EndDialog( hDlg, 1 );
					return TRUE;
			}
			break;
	}

	return FALSE;
}

BOOL
CALLBACK
HelpDlgProc( HWND hDlg,
						 UINT uMsg,
						 WPARAM wParam,
						 LPARAM lParam )
{
	switch( uMsg ) {
		case WM_INITDIALOG:
				return TRUE;

		case WM_COMMAND:
			switch( LOWORD( wParam ) ) {
				case IDOK:
					EndDialog( hDlg, 1 );
					return TRUE;
			}
			break;
	}

	return FALSE;
}
